/*
 * CPT - a Constraint Programming Temporal planner
 *
 * File : globs.h
 *
 * Copyright (C) 2005, 2006  Vincent Vidal <vidal@cril.univ-artois.fr>
 */


#ifndef GLOBS_H
#define GLOBS_h


#include "structs.h"
#include "plan.h"


EXTERN_TAB(Action *, actions);
EXTERN_TAB(Fluent *, fluents);
EXTERN_TAB(Causal *, causals);
EXTERN_TAB(Action *, active_actions);
EXTERN_TAB(Causal *, active_causals);
EXTERN_TAB(Property, properties);
EXTERN_TAB(Resource *, resources);

extern Action *start_action;
extern Action *end_action;

EXTERN_TAB(Fluent *, init_state);
EXTERN_TAB(Fluent *, goal_state);

extern SolutionPlan *solution_plan;
EXTERN_TAB(SolutionPlan *, plans);

extern Time time_pgcd;
extern Time time_ppcm;

extern long nb_support_choices;
extern long nb_conflict_choices;
extern long nb_mutex_choices;
extern long nb_start_time_choices;

extern Causal *last_choice;


#endif /* GLOBS_H */
