/*
 * CPT - a Constraint Programming Temporal planner
 *
 * File : solve.h
 *
 * Copyright (C) 2005, 2006  Vincent Vidal <vidal@cril.univ-artois.fr>
 */


#ifndef SOLVE_H
#define SOLVE_H 


#define PLAN_FOUND 0
#define GOALS_MUTEX 1
#define INIT_PROP_FAILED 2
#define BACKTRACK_LIMIT 3
#define BOUND_LIMIT 4
#define HYBRID 5

typedef bool (*hook) (int);

extern void init_hooks(hook ps, hook pf, hook plf, hook plnf);

#define call_hook(h, arg) (h != NULL ? h(arg) : true)

extern int cpt_main(int argc, char **argv);
extern int cpt_basic_search(void);
extern int cpt_search(Fluent **init, Num init_nb, Fluent **goals, Num goals_nb, bool compress, bool compress_causals, bool compress_orderings);


#endif /* SOLVE_H */
